#include "led.h"

//Функция инициализации светодиода VD5...VD7
void led_Init(void)
{
	//Создание структуры для инициализации порта	
	PORT_InitTypeDef PORT_InitStructure;
	
	//Настройки порта: вывод, функция ввода/вывода, цифровой режим, максимальная скорость, Pin6 - VD5
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	PORT_InitStructure.PORT_Pin = (PORT_Pin_6);
	
	PORT_Init(MDR_PORTE, &PORT_InitStructure);				
	
	
	//Настройки порта: вывод, функция ввода/вывода, цифровой режим, максимальная скорость, Pin0, Pin15 - VD6, VD7
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	PORT_InitStructure.PORT_Pin = (PORT_Pin_0 | PORT_Pin_15);
	
	PORT_Init(MDR_PORTB, &PORT_InitStructure);	
}

//Функция записи состояния (1:0) светодиода VD5...VD7
void led_Write(int led ,bool on_off)
{
	switch(led)
	{
		case 0: // VD5
	    PORT_WriteBit(MDR_PORTE, PORT_Pin_6, on_off ? Bit_SET : Bit_RESET);
    break;
		
		case 1: // VD6
	    PORT_WriteBit(MDR_PORTB, PORT_Pin_0, on_off ? Bit_SET : Bit_RESET);
    break;
		
		case 2: // VD7
	    PORT_WriteBit(MDR_PORTB, PORT_Pin_15, on_off ? Bit_SET : Bit_RESET);
    break;
	}		
}
